(function (window) {
  if (window._YJJSINIT) return
  window._YJJSINIT = true;
  var platform = (function () {
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;
      if (/android/i.test(userAgent)) {
        return "android";
      }
      if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
        return "ios";
      }
      return false;
  })();

  if (!platform) return;
  var EVENT_MSG_CONFIG = {
    postMessage: function (name, args) {
      switch (platform) {
        case 'ios':
          window.webkit.messageHandlers[name].postMessage(args);
          break;
        case 'android':
          window.HtmlHandler[name].apply(window.HtmlHandler, Object.keys(args).map(function (key) {
            return args[key];
          }));
          break;
      }
    }
  };

  var FullscreenApi = (function () {
    var _FullscreenApi = {};
    // browser API methods
    var apiMap = [['requestFullscreen', 'exitFullscreen', 'fullscreenElement', 'fullscreenEnabled', 'fullscreenchange', 'fullscreenerror', 'fullscreen'],
    // WebKit
    ['webkitRequestFullscreen', 'webkitExitFullscreen', 'webkitFullscreenElement', 'webkitFullscreenEnabled', 'webkitfullscreenchange', 'webkitfullscreenerror', 'webkitIsFullScreen'],
    // Old WebKit (Safari 5.1)
    ['webkitRequestFullScreen', 'webkitCancelFullScreen', 'webkitCurrentFullScreenElement', 'webkitCancelFullScreen', 'webkitfullscreenchange', 'webkitfullscreenerror', 'webkitIsFullScreen'],
    // Mozilla
    ['mozRequestFullScreen', 'mozCancelFullScreen', 'mozFullScreenElement', 'mozFullScreenEnabled', 'mozfullscreenchange', 'mozfullscreenerror', 'mozFullScreen'],
    // Microsoft
    ['msRequestFullscreen', 'msExitFullscreen', 'msFullscreenElement', 'msFullscreenEnabled', 'MSFullscreenChange', 'MSFullscreenError', 'fullscreen']];
    var specApi = apiMap[0];
    var browserApi = void 0;
    // determine the supported set of functions
    for (var i = 0; i < apiMap.length; i++) {
      // check for exitFullscreen function
      if (apiMap[i][1] in document) {
        browserApi = apiMap[i];
        break;
      }
    }
    // map the browser API names to the spec API names
    if (browserApi) {
      for (var _i = 0; _i < browserApi.length; _i++) {
        _FullscreenApi[specApi[_i]] = browserApi[_i];
      }
    }
    return _FullscreenApi;
  })();

  function YJProxy (siteId) {
    var player = null;
    var pVId = false;
    var pAId = false;
    var initialized = false;
    var metaKeyMap = ['duration', 'videoHeight', 'videoWidth']
    var meta = {};
    var status = 'INITIAL';
    var isFirstPlay = true;
    var isAd = true;

    var init = function () {
      if (initialized) return;
      switch (siteId) {
        case 'kumi':
          if (!(pVId || pAId)) {
            var re = /\S*\/(\d*)_(\d*)\S*/i;
            if (found = location.href.match(re)) {
              pAId = found[1];
              pVId = found[2];
            }
          }
          initialized = true;
          break;
        case 'letv':
          if (!(pVId || pAId) && info) {
            pAId = info.pid;
            pVId = info.vid;
          }
          var letvVideoWrap = document.getElementById('j-player');
          var letvVideo = letvVideoWrap ? letvVideoWrap.querySelector('video') : null;
          if (letvVideo) {
            player = letvVideo;
            initialized = true;
          }
          break;
        case 'mgtv':
          player = document.getElementById('player');
          if (!(pVId || pAId)) {
            var re = /\S*\/#\/\S*\/(\d*)\/(\d*)\S*/i;
            if (found = location.href.match(re)) {
              pAId = found[1];
              pVId = found[2];
            }
          }
          if (player) {
            initialized = true;
          }
          break;
        case 'v1905':
          player = document.getElementById('zy_video');
          if (!pVId) {
            var re = /\S*\/(\d*).shtml/i;
            if (found = location.href.match(re)) {
              pVId = pAId = found[1];
            }
          }
          if (player) {
            initialized = true;
          }
          break;
        case 'qq':
          if (document.getElementsByTagName('video').length) {
            player = document.getElementsByTagName('video')[0]
          }
          var params = getLocationParams();
          pVId = params['vid']
          pAId = params['cid']
          if (!pAId || !pVId) {
            var re = /\S*\/cover\/\S*\/(\S*)\/(\S*).html/i;
            if (found = location.href.match(re)) {
              pAId = found[1];
              pVId = found[2];
            }
          }
          if (player) {
            initialized = true;
          }
          break;
        case 'iqiyi':
          if (document.getElementsByTagName('video').length) {
            player = document.getElementsByTagName('video')[0]
          }
          if (Qiyi && Qiyi.PageInfo && Qiyi.PageInfo.playInfo) {
            pVId = Qiyi.PageInfo.playInfo.vid;
            pAId = Qiyi.PageInfo.playInfo.aid;
          }
          if (player) {
            initialized = true;
          }
          break;
        case 'sohu':
          if (document.getElementsByTagName('video').length) {
            player = document.getElementsByTagName('video')[0]
          }
          if (videoData) {
            pVId = videoData.vid;
            pAId = videoData.sid;
          }
          if (player) {
            initialized = true;
          }
          break;
        case 'youku':
          if (document.getElementsByTagName('video').length) {
            player = document.getElementsByTagName('video')[0]
          }
          var re = /\S*\/video\/id_(\S*).html/i;
          if (found = location.href.match(re)) {
            pVId = pAId = found[1];
          }
          if (player) {
            initialized = true;
          }
          break;
      }
      if (initialized) {
        bindEvents(player);
        EVENT_MSG_CONFIG.postMessage('setAidAndVid', {
          pAId: pAId,
          pVId: pVId
        });
      }
    }

    function checkIsAd() {
      switch (siteId) {
        case 'kumi':
          isAd = true;
          break;
        case 'letv':
          isAd = document.querySelector('.vdo_post_time') != null;
          break;
        case 'mgtv':
          isAd = document.querySelector('.mg-video').className.indexOf('ad') > 0;
          break;
        case 'v1905':
          isAd = false;
          break;
        case 'qq':
          if (document.querySelector('.txp_ad_more')) {
            isAd = document.querySelector('.txp_ad_more').offsetLeft > 0;
          }
          break;
        case 'iqiyi':
          isAd = player.src.indexOf('qd_vip') < 0;
          break;
        case 'sohu':
          if (document.querySelector('.ad-info-show')) {
            isAd = document.querySelector('.ad-info-show').style.display != "none";
          }
          break;
        case 'youku':
          if (document.querySelector('.x-advert')) {
            isAd = document.querySelector('.x-advert').style.display != "none";
          }
        default:
          isAd = player.duration < 30 ? true : false;
      }
    }

    var bindEvents = function (player) {
      if (!player) return false;
      if (player.__markasinitialized__) return;
      player.__markasinitialized__ = true;
      player.addEventListener('loadedmetadata', function (e) {
        metaKeyMap.forEach(function (key) {
          meta[key] = e.currentTarget[key];
        })
        if (siteId === 'letv' && info && info.vid !== pVId) {
          pAId = info.pid;
          pVId = info.vid;
          EVENT_MSG_CONFIG.postMessage('setAidAndVid', {
            pAId: pAId,
            pVId: pVId
          });
          isFirstPlay = true;
          isAd = true;
        }
      });
      if (!EVENT_MSG_CONFIG.postMessage) return;

      // playing
      player.addEventListener('playing', function (e) {
        checkIsAd();
        EVENT_MSG_CONFIG.postMessage('play', {
          isFirstPlay: isFirstPlay,
          isAd: isAd
        });
        isFirstPlay = false;
      });

      // pause
      player.addEventListener('pause', function (e) {
        EVENT_MSG_CONFIG.postMessage('pause', {
          position: player.currentTime,
          isAd: isAd
        });
      });

      // waiting
      player.addEventListener('waiting', function (e) {
        EVENT_MSG_CONFIG.postMessage('pause', {
          position: player.currentTime,
          isAd: isAd
        });
      });

      // error
      player.addEventListener('error', function (e) {
        EVENT_MSG_CONFIG.postMessage('error', {
          position: player.currentTime,
          isAd: isAd
        });
      });

      // ended
      player.addEventListener('ended', function (e) {
        isFirstPlay = true;
        EVENT_MSG_CONFIG.postMessage('ended', {
          isAd: isAd
        });
        isAd = true;
      });

      if (siteId === 'letv' && platform === 'android') {
        if (document.querySelector('.hv_ico_screen')) {
          document.querySelector('.hv_ico_screen').addEventListener('touchend', function (e) {
            EVENT_MSG_CONFIG.postMessage('onFullScreen', {
              isFullScreen: !(e.currentTarget.className.indexOf('hv_ico_allscreen') === -1)
            });
          })
        }
      } else if (siteId === 'qq' && platform === 'android') {
        if (document.querySelector('.txp_btn_fullscreen')) {
          document.querySelector('.txp_btn_fullscreen').addEventListener('touchend', function (e) {
            EVENT_MSG_CONFIG.postMessage('onFullScreen', {
              isFullScreen: document.querySelector('.txp_btn_fullscreen').attributes['data-status'].value  === 'false'
            });
          })
        }
      } else if (siteId === 'sohu' && platform === 'android') {
        if (document.querySelector('.x-fs-btn')) {
          document.querySelector('.x-fs-btn').addEventListener('touchend', function (e) {
            EVENT_MSG_CONFIG.postMessage('onFullScreen', {
              isFullScreen: true
            });
          })
          document.querySelector('.x-exit-fs-btn').addEventListener('touchend', function (e) {
            EVENT_MSG_CONFIG.postMessage('onFullScreen', {
              isFullScreen: false
            });
          })
        }
      }else {
        player.addEventListener(FullscreenApi['fullscreenchange'], function (e) {
          EVENT_MSG_CONFIG.postMessage('onFullScreen', {
            isFullScreen: !!document[FullscreenApi['fullscreen']]
          });
        });
      }
    };

    return {
      getPlayer: function () {
        if (!initialized) init();
        return player;
      },
      refreshPlayer: function () {
        player = null;
        pVId = false;
        pAId = false;
        initialized = false;
        isFirstPlay = true;
        isAd = true;
        init();
        return player;
      },
      getMetaData: function () {
        return meta;
      },
      getPVId: function () {
        return pVId;
      },
      getPAId: function () {
        return pAId;
      }
    };
  };

  function refresh () {
    setTimeout(function () {
      if(!YJJsUtil.refresh()) {
        refresh();
      }
    }, 500);
  }

  var onInjectStart = function (siteId) {
    if (siteId === 'mgtv') {
      window.addEventListener('hashchange', function (e) {
        if (!YJJsUtil) return;
        refresh();
      })
    }
  };

  function getLocationParams () {
    var search = location.search
    var params = {}
    if (search) {
      var str = search.split('?')[1]
      str.split('&').map(function (item) {
        params[item.split('=')[0]] = item.split('=')[1]
      })
    }
    return params
  }

  window.YJInjectJs = function (siteId) {
    if (window._YJINJECT) return true;
    window._YJINJECT = true;
    var startTime = Date.now();
    onInjectStart(siteId);
    window.YJJsUtil = {
      proxy: YJProxy(siteId),
      play: function () {
        if (!this.proxy.getPlayer()) return false;
        this.proxy.getPlayer().play();
      },
      pause: function () {
        if (!this.proxy.getPlayer()) return false;
        this.proxy.getPlayer().pause();
      },
      paused: function () {
        if (!this.proxy.getPlayer()) return false;
        return this.proxy.getPlayer().paused();
      },
      onOrientationChanged: function (landscape) {
        var player = this.proxy.getPlayer();
        if (!player) return false;
        if (siteId === 'mgtv') {
          landscape === 1 ? this.enterFullscreen() : this.exitFullscreen();
        }
        return true;
      },
      getVideoPosition: function () {
        var player = this.proxy.getPlayer();
        var meta = this.proxy.getMetaData();
        if (!player) return false;
        if (!player || !Object.keys(meta).length) return false
        return player.currentTime
      },
      setVideoPosition: function (position) {
        var player = this.proxy.getPlayer();
        var meta = this.proxy.getMetaData();
        if (!player || !Object.keys(meta).length) return false;
        player.currentTime = position;
        return true;
      },
      enterFullscreen: function () {
        var player = this.proxy.getPlayer();
        if (!player) return false;
        if (siteId === 'letv' && document.querySelector('.hv_ico_screen')) {
          document.querySelector('.hv_ico_screen').dispatchEvent(new MouseEvent('touchend'));
        } else if (siteId === 'qq' && platform === 'android' && document.querySelector('.txp_btn_fullscreen')) {
          if (document.querySelector('.txp_btn_fullscreen').attributes['data-status'].value === 'false') {
            document.querySelector('.txp_btn_fullscreen').dispatchEvent(new MouseEvent('touchend'));
          }
        } else {
          player[FullscreenApi['requestFullscreen']]();
        }
        if (siteId === 'mgtv' && platform === 'android') {
          var $videoArea = document.querySelector('.video-area')
          var $offscreenBtn = document.querySelector('.app-a-go.on')
          var $header = document.querySelector('.m-headerbar')
          if ($header) {
            $header.style.display = 'none'
          }
          if ($offscreenBtn) {
            $offscreenBtn.style.display = 'none'
          }
        }
        EVENT_MSG_CONFIG.postMessage('onFullScreen', {
          isFullScreen: true
        });
        return true;
      },
      exitFullscreen: function () {
        var player = this.proxy.getPlayer();
        if (!player) return false;
        if (siteId === 'letv' && document.querySelector('.hv_ico_allscreen')) {
          document.querySelector('.hv_ico_allscreen').dispatchEvent(new MouseEvent('touchend'));
        } else if (siteId === 'qq' && platform === 'android' && document.querySelector('.txp_btn_fullscreen')) {
          if (document.querySelector('.txp_btn_fullscreen').attributes['data-status'].value === 'true') {
            document.querySelector('.txp_btn_fullscreen').dispatchEvent(new MouseEvent('touchend'));
          }
        } else {
          player[FullscreenApi['exitFullscreen']]();
        }
        if (siteId === 'mgtv' && platform === 'android') {
          var $videoArea = document.querySelector('.video-area')
          var $offscreenBtn = document.querySelector('.app-a-go.on')
          var $header = document.querySelector('.m-headerbar')
          if ($header) {
            $header.style.display = 'block'
          }
          if ($offscreenBtn) {
            $offscreenBtn.style.display = 'block'
          }
          window.scrollTo(0, 0)
        }
        EVENT_MSG_CONFIG.postMessage('onFullScreen', {
          isFullScreen: false
        });
        return true;
      },
      init: function () {
        if (platform !== 'ios') {
          if (window._YJINJECTINIT) return true;
          window._YJINJECTINIT = true;
        }
        YJJsUtil._init();
        return true;
      },
      _init: function () {
        setTimeout(function () {
          var player = YJJsUtil.proxy.getPlayer();
          var now = Date.now();
          if (!player && siteId !== 'kumi' && (now - startTime) <= 180000) {
            YJJsUtil._init()
          }
        }, 500);
      },
      getPVId: function () {
        return this.proxy.getPVId();
      },
      getPAId: function () {
        return this.proxy.getPAId();
      },
      refresh: function () {
        var player = this.proxy.refreshPlayer();
        if (siteId === 'kumi') return true;
        return !!player;
      }
    }
    return true;
  }
})(window);